#include "X3D_Transform.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

Transform::Transform()
: X3DGroupingNode(), X3DBoundedObject()
{
  define(Recorder<Transform>::getTypeName("Transform", "Grouping"));
  
  define(Recorder<Transform, SFVec3f>::getAttribute("center", &Transform::_center, SFVec3f(0.0f, 0.0f, 0.0f)));
  define(Recorder<Transform, SFRotation>::getAttribute("rotation", &Transform::_rotation, SFRotation(0.0f, 0.0f, 1.0f, 0.0f)));
  define(Recorder<Transform, SFVec3f>::getAttribute("scale", &Transform::_scale, SFVec3f(1.0f, 1.0f, 1.0f)));
  define(Recorder<Transform, SFRotation>::getAttribute("scaleOrientation", &Transform::_scaleOrientation, SFRotation(0.0f, 0.0f, 1.0f, 0.0f)));
  define(Recorder<Transform, SFVec3f>::getAttribute("translation", &Transform::_translation, SFVec3f(0.0f, 0.0f, 0.0f)));
}

Transform::~Transform()
{
}

void Transform::setCenter(const SFVec3f &center)
{
  _center = center;
}

void Transform::setRotation(const SFRotation &rotation)
{
  _rotation = rotation;
}

void Transform::setScale(const SFVec3f &scale)
{
  _scale = scale;
}

void Transform::setScaleOrientation(const SFRotation &scaleOrientation)
{
  _scaleOrientation = scaleOrientation;
}

void Transform::setTranslation(const SFVec3f &translation)
{
  _translation = translation;
}

}
}
