#include "X3D_PointLight.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

PointLight::PointLight()
: X3DLightNode()
{
  define(Recorder<PointLight>::getTypeName("PointLight", "Lighting"));
  
  define(Recorder<PointLight, SFVec3f>::getAttribute("attenuation", &PointLight::_attenuation, SFVec3f(0.0f,0.0f,0.0f)));
  define(Recorder<PointLight, SFVec3f>::getAttribute("location", &PointLight::_location, SFVec3f(0.0f,0.0f,0.0f)));
  define(Recorder<PointLight, SFFloat>::getAttribute("radius ", &PointLight::_radius, 100.0f));
}

PointLight::~PointLight()
{
}

void PointLight::setAttenuation(const SFVec3f &attenuation)
{
  _attenuation = attenuation;
}

void PointLight::setLocation(const SFVec3f &location)
{
  _location = location;
}

void PointLight::setRadius(const SFFloat &radius)
{
  _radius = radius;
}

}
}
