#include "X3D_NurbsCurve2D.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

NurbsCurve2D::NurbsCurve2D()
: X3DParametricGeometryNode()
{
  define(Recorder<NurbsCurve2D>::getTypeName("NurbsCurve2D", "NURBS"));
  
  define(Recorder<NurbsCurve2D, MFVec2f>::getAttribute("controlPoint", &NurbsCurve2D::_controlPoint, MFVec2f()));
  define(Recorder<NurbsCurve2D, SFInt32>::getAttribute("tesselation", &NurbsCurve2D::_tesselation, 0));
  define(Recorder<NurbsCurve2D, MFDouble>::getAttribute("weight", &NurbsCurve2D::_weight, MFDouble()));
  define(Recorder<NurbsCurve2D, MFDouble>::getAttribute("knot", &NurbsCurve2D::_knot, MFDouble()));
  define(Recorder<NurbsCurve2D, SFInt32>::getAttribute("order", &NurbsCurve2D::_order, 3));  
}

NurbsCurve2D::~NurbsCurve2D()
{
}

void NurbsCurve2D::setControlPoint(const MFVec2f &controlPoint)
{
  _controlPoint = controlPoint;
}

void NurbsCurve2D::setTesselation(const SFInt32 &tesselation)
{
  _tesselation = tesselation;
}

void NurbsCurve2D::setWeight(const MFDouble &weight)
{
  _weight = weight;
}

void NurbsCurve2D::setKnot(const MFDouble &knot)
{
  _knot = knot;
}

void NurbsCurve2D::setOrder(const SFInt32 &order)
{
  _order = order;
}

}
}
