#include "X3D_TriangleFanSet.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

TriangleFanSet::TriangleFanSet()
: X3DComposedGeometryNode()
{
  define(Recorder<TriangleFanSet>::getTypeName("TriangleFanSet", "Rendering"));
  
  define(Recorder<TriangleFanSet, SFBool>::getAttribute("convex", &TriangleFanSet::_convex, true));
  define(Recorder<TriangleFanSet, SFFloat>::getAttribute("creaseAngle", &TriangleFanSet::_creaseAngle, 0.0f));
  define(Recorder<TriangleFanSet, MFInt32>::getAttribute("fanCount", &TriangleFanSet::_fanCount, MFInt32()));
}

TriangleFanSet::~TriangleFanSet()      
{
}

void TriangleFanSet::setConvex(const SFBool &convex)
{
  _convex = convex;
}

void TriangleFanSet::setCreaseAngle(const SFFloat &creaseAngle)
{
  _creaseAngle = creaseAngle;
}

void TriangleFanSet::setFanCount(const MFInt32 &fanCount)
{
  _fanCount  = fanCount;
}

}
}
