#include "X3D_Material.h"

namespace X3DTK {
namespace X3D {

Material::Material()
: X3DMaterialNode()
{ 
  define(Recorder<Material>::getTypeName("Material", "Shape"));

  define(Recorder<Material, SFFloat>::getAttribute("ambientIntensity", &Material::_ambientIntensity, 0.2f));
  define(Recorder<Material, SFColor>::getAttribute("diffuseColor", &Material::_diffuseColor, SFColor(0.8f, 0.8f, 0.8f)));
  define(Recorder<Material, SFColor>::getAttribute("emissiveColor", &Material::_emissiveColor, SFColor(0.0f, 0.0f, 0.0f)));
  define(Recorder<Material, SFFloat>::getAttribute("shininess", &Material::_shininess, 0.2f));
  define(Recorder<Material, SFColor>::getAttribute("specularColor", &Material::_specularColor,SFColor(0.0f, 0.0f, 0.0f) ));
  define(Recorder<Material, SFFloat>::getAttribute("transparency", &Material::_transparency, 0.0f));
}

Material::~Material()
{
}

void Material::setAmbientIntensity(const SFFloat &ambientIntensity)
{
  _ambientIntensity = ambientIntensity;
}

void Material::setDiffuseColor(const SFColor &diffuseColor)
{
  _diffuseColor = diffuseColor;
}

void Material::setEmissiveColor(const SFColor &emissiveColor)  
{
  _emissiveColor = emissiveColor;
}

void Material::setShininess(const SFFloat &shininess)  
{
  _shininess = shininess;
}

void Material::setSpecularColor(const SFColor &specularColor)  
{
  _specularColor = specularColor;  
}

void Material::setTransparency(const SFFloat &transparency)  
{
  _transparency = transparency;
}

}
}
